{ ***************************************************************************
  written by eSeGeCe
  copyright  2022
  Email : info@esegece.com
  Web : http://www.esegece.com
  *************************************************************************** }

unit uChatGPT;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.JSON, sgcHTTP;

type
  TForm4 = class(TForm)
    btnChatGPT: TButton;
    txtQuestion: TEdit;
    memoResponse: TMemo;
    Label1: TLabel;
    txtAPI: TEdit;
    Label2: TLabel;
    procedure btnChatGPTClick(Sender: TObject);
  end;

function AskChatGPT(const aAPI, aQuestion: string): string;

var
  Form4: TForm4;

implementation

{$R *.dfm}

function AskChatGPT(const aAPI, aQuestion: string): string;
var
  oHTTP: TsgcHTTP1Client;
  oStream: TStringStream;
  vPostData: string;
  oJSON: TJSONValue;
  oArray: TJSonArray;
begin
  oHTTP := TsgcHTTP1Client.Create(nil);
  Try
    oHTTP.Request.CustomHeaders.Add('Authorization: Bearer ' + aAPI);
    oHTTP.Request.ContentType := 'application/json';
    vPostData :=
      Format('{"model": "text-davinci-003","prompt": "%s","max_tokens": 2048,"temperature": 0}',
      [aQuestion]);

    // send request
    oStream := TStringStream.Create(vPostData);
    Try
      result := oHTTP.Post('https://api.openai.com/v1/completions', oStream);
      // parse response
      oJSON := TJSonObject.ParseJSONValue(result).GetValue<TJSONValue>
        ('choices');
      result := TJSonArray(oJSON).Items[0].GetValue<TJSONString>('text').Value;
    Finally
      oStream.Free;
    End;
  Finally
    oHTTP.Free;
  End;
end;

procedure TForm4.btnChatGPTClick(Sender: TObject);
begin
  memoResponse.Text := AskChatGPT(txtAPI.Text, txtQuestion.Text);
end;

end.
